#include <linux/module.h>
#define INCLUDE_VERMAGIC
#include <linux/build-salt.h>
#include <linux/elfnote-lto.h>
#include <linux/export-internal.h>
#include <linux/vermagic.h>
#include <linux/compiler.h>

#ifdef CONFIG_UNWINDER_ORC
#include <asm/orc_header.h>
ORC_HEADER;
#endif

BUILD_SALT;
BUILD_LTO_INFO;

MODULE_INFO(vermagic, VERMAGIC_STRING);
MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

#ifdef CONFIG_RETPOLINE
MODULE_INFO(retpoline, "Y");
#endif

KSYMTAB_FUNC(sas_register_ha, "_gpl", "");
KSYMTAB_FUNC(sas_unregister_ha, "_gpl", "");
KSYMTAB_FUNC(sas_phy_enable, "_gpl", "");
KSYMTAB_FUNC(sas_phy_reset, "_gpl", "");
KSYMTAB_FUNC(sas_prep_resume_ha, "", "");
KSYMTAB_FUNC(sas_resume_ha, "", "");
KSYMTAB_FUNC(sas_resume_ha_no_sync, "", "");
KSYMTAB_FUNC(sas_suspend_ha, "", "");
KSYMTAB_DATA(dev_attr_phy_event_threshold, "_gpl", "");
KSYMTAB_FUNC(sas_domain_attach_transport, "_gpl", "");
KSYMTAB_FUNC(sas_drain_work, "_gpl", "");
KSYMTAB_FUNC(sas_notify_port_event, "_gpl", "");
KSYMTAB_FUNC(sas_notify_phy_event, "_gpl", "");
KSYMTAB_FUNC(sas_find_attached_phy_id, "_gpl", "");
KSYMTAB_FUNC(sas_queuecommand, "_gpl", "");
KSYMTAB_FUNC(sas_get_local_phy, "_gpl", "");
KSYMTAB_FUNC(sas_eh_abort_handler, "_gpl", "");
KSYMTAB_FUNC(sas_eh_device_reset_handler, "_gpl", "");
KSYMTAB_FUNC(sas_eh_target_reset_handler, "_gpl", "");
KSYMTAB_FUNC(sas_ioctl, "_gpl", "");
KSYMTAB_FUNC(sas_target_alloc, "_gpl", "");
KSYMTAB_FUNC(sas_slave_configure, "_gpl", "");
KSYMTAB_FUNC(sas_change_queue_depth, "_gpl", "");
KSYMTAB_FUNC(sas_bios_param, "_gpl", "");
KSYMTAB_FUNC(sas_execute_internal_abort_single, "_gpl", "");
KSYMTAB_FUNC(sas_execute_internal_abort_dev, "_gpl", "");
KSYMTAB_FUNC(sas_abort_task_set, "_gpl", "");
KSYMTAB_FUNC(sas_clear_task_set, "_gpl", "");
KSYMTAB_FUNC(sas_lu_reset, "_gpl", "");
KSYMTAB_FUNC(sas_query_task, "_gpl", "");
KSYMTAB_FUNC(sas_abort_task, "_gpl", "");
KSYMTAB_FUNC(sas_task_abort, "_gpl", "");
KSYMTAB_FUNC(sas_slave_alloc, "_gpl", "");
KSYMTAB_FUNC(sas_target_destroy, "_gpl", "");
KSYMTAB_FUNC(sas_request_addr, "_gpl", "");
KSYMTAB_FUNC(sas_ssp_task_response, "_gpl", "");
KSYMTAB_FUNC(try_test_sas_gpio_gp_bit, "", "");

SYMBOL_CRC(sas_register_ha, 0x079e5534, "_gpl");
SYMBOL_CRC(sas_unregister_ha, 0xde1cf738, "_gpl");
SYMBOL_CRC(sas_phy_enable, 0xa364ede9, "_gpl");
SYMBOL_CRC(sas_phy_reset, 0x99d5a548, "_gpl");
SYMBOL_CRC(sas_prep_resume_ha, 0x849331ac, "");
SYMBOL_CRC(sas_resume_ha, 0x9717ad5c, "");
SYMBOL_CRC(sas_resume_ha_no_sync, 0xe399b158, "");
SYMBOL_CRC(sas_suspend_ha, 0xbed08237, "");
SYMBOL_CRC(dev_attr_phy_event_threshold, 0x47d03800, "_gpl");
SYMBOL_CRC(sas_domain_attach_transport, 0xc6f2e6ad, "_gpl");
SYMBOL_CRC(sas_drain_work, 0xc11dce5c, "_gpl");
SYMBOL_CRC(sas_notify_port_event, 0xd0dc2482, "_gpl");
SYMBOL_CRC(sas_notify_phy_event, 0x4bcb9077, "_gpl");
SYMBOL_CRC(sas_find_attached_phy_id, 0xd8abf9eb, "_gpl");
SYMBOL_CRC(sas_queuecommand, 0x76b2f95d, "_gpl");
SYMBOL_CRC(sas_get_local_phy, 0x2ff1aff6, "_gpl");
SYMBOL_CRC(sas_eh_abort_handler, 0x3dfb3886, "_gpl");
SYMBOL_CRC(sas_eh_device_reset_handler, 0x14e5614b, "_gpl");
SYMBOL_CRC(sas_eh_target_reset_handler, 0x8bf60e23, "_gpl");
SYMBOL_CRC(sas_ioctl, 0xce53a8ec, "_gpl");
SYMBOL_CRC(sas_target_alloc, 0xa3de1a7b, "_gpl");
SYMBOL_CRC(sas_slave_configure, 0x84b81727, "_gpl");
SYMBOL_CRC(sas_change_queue_depth, 0xd3d8ea78, "_gpl");
SYMBOL_CRC(sas_bios_param, 0x3c98a708, "_gpl");
SYMBOL_CRC(sas_execute_internal_abort_single, 0x69ca629a, "_gpl");
SYMBOL_CRC(sas_execute_internal_abort_dev, 0x989afa94, "_gpl");
SYMBOL_CRC(sas_abort_task_set, 0x70977651, "_gpl");
SYMBOL_CRC(sas_clear_task_set, 0x7edb62c6, "_gpl");
SYMBOL_CRC(sas_lu_reset, 0xafc54452, "_gpl");
SYMBOL_CRC(sas_query_task, 0x21c9d53d, "_gpl");
SYMBOL_CRC(sas_abort_task, 0x57c76a94, "_gpl");
SYMBOL_CRC(sas_task_abort, 0xf4b86aab, "_gpl");
SYMBOL_CRC(sas_slave_alloc, 0x5f06e476, "_gpl");
SYMBOL_CRC(sas_target_destroy, 0xbe5000e4, "_gpl");
SYMBOL_CRC(sas_request_addr, 0x4d164b1e, "_gpl");
SYMBOL_CRC(sas_ssp_task_response, 0xd9f1ead2, "_gpl");
SYMBOL_CRC(try_test_sas_gpio_gp_bit, 0x4a8e3d34, "");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0xc6d09aa9, "release_firmware" },
	{ 0x7696f8c7, "__list_add_valid_or_report" },
	{ 0x49cd25ed, "alloc_workqueue" },
	{ 0x4f248a45, "sas_rphy_remove" },
	{ 0xa38602cd, "drain_workqueue" },
	{ 0x54457215, "bsg_job_done" },
	{ 0x656e4a6e, "snprintf" },
	{ 0xa6257a2f, "complete" },
	{ 0xcdc6d04f, "sas_rphy_unlink" },
	{ 0xc5b6f236, "queue_work_on" },
	{ 0xb742fd7, "simple_strtol" },
	{ 0x608741b5, "__init_swait_queue_head" },
	{ 0x92540fbf, "finish_wait" },
	{ 0x219eb36, "scsi_schedule_eh" },
	{ 0x6107dfe4, "request_firmware" },
	{ 0x96848186, "scnprintf" },
	{ 0xb9082bad, "sas_port_alloc" },
	{ 0x4829a47e, "memcpy" },
	{ 0x37a0cba, "kfree" },
	{ 0x2a0ffd6, "scsi_eh_ready_devs" },
	{ 0x54496b4, "schedule_timeout_interruptible" },
	{ 0xf0898f93, "sas_port_get_phy" },
	{ 0x43babd19, "sg_init_one" },
	{ 0x5ed90adc, "int_to_scsilun" },
	{ 0xdc0e4855, "timer_delete" },
	{ 0x8c26d495, "prepare_to_wait_event" },
	{ 0x82ee90dc, "timer_delete_sync" },
	{ 0xe2964344, "__wake_up" },
	{ 0x26c90ea4, "scsi_eh_get_sense" },
	{ 0x412730c8, "kmem_cache_create" },
	{ 0xe127bd74, "get_device" },
	{ 0x34db050b, "_raw_spin_lock_irqsave" },
	{ 0xba8fbd64, "_raw_spin_lock" },
	{ 0xcbd4898c, "fortify_panic" },
	{ 0x50cf7585, "hex2bin" },
	{ 0x3ec2f953, "sas_phy_alloc" },
	{ 0x122c3a7e, "_printk" },
	{ 0x8427cc7b, "_raw_spin_lock_irq" },
	{ 0x8ddd8aad, "schedule_timeout" },
	{ 0x296695f, "refcount_warn_saturate" },
	{ 0xe16b094c, "put_device" },
	{ 0xa916b694, "strnlen" },
	{ 0x922db506, "kmem_cache_alloc" },
	{ 0x876e5cd3, "_dev_info" },
	{ 0xa85b1d0d, "sas_phy_free" },
	{ 0x982ed170, "scsi_eh_finish_cmd" },
	{ 0xf811e69d, "scsi_eh_flush_done_q" },
	{ 0xfe487975, "init_wait_entry" },
	{ 0x24d273d1, "add_timer" },
	{ 0x88914935, "sas_port_add" },
	{ 0x8c03d20c, "destroy_workqueue" },
	{ 0x4dfa8d4b, "mutex_lock" },
	{ 0xf9fca5a5, "sas_port_mark_backlink" },
	{ 0xa74e0693, "kmem_cache_free" },
	{ 0x4b750f53, "_raw_spin_unlock_irq" },
	{ 0x950eb34e, "__list_del_entry_valid_or_report" },
	{ 0xcefb0c9f, "__mutex_init" },
	{ 0x755af69b, "sas_end_device_alloc" },
	{ 0x89940875, "mutex_lock_interruptible" },
	{ 0x42df315, "sas_read_port_mode_page" },
	{ 0xd35cce70, "_raw_spin_unlock_irqrestore" },
	{ 0x2395e191, "sas_expander_alloc" },
	{ 0xdcb764ad, "memset" },
	{ 0x7ebc429e, "_dev_warn" },
	{ 0xed6864a0, "sas_rphy_delete" },
	{ 0x8d158c1a, "scsi_is_host_device" },
	{ 0x25974000, "wait_for_completion" },
	{ 0x54fdcbdf, "sas_attach_transport" },
	{ 0x9166fc03, "__flush_workqueue" },
	{ 0xd9a5ea54, "__init_waitqueue_head" },
	{ 0x3bff8038, "scsi_host_busy" },
	{ 0x12abef1, "sas_port_delete" },
	{ 0x15ba50a6, "jiffies" },
	{ 0x3c3ff9fd, "sprintf" },
	{ 0xe45d32be, "sas_rphy_add" },
	{ 0xeb99f8bd, "__pm_runtime_resume" },
	{ 0x9c87449d, "sas_port_delete_phy" },
	{ 0x3213f038, "mutex_unlock" },
	{ 0xc6f46339, "init_timer_key" },
	{ 0xd4abaf0c, "sas_rphy_free" },
	{ 0x2cf56265, "__dynamic_pr_debug" },
	{ 0x56470118, "__warn_printk" },
	{ 0xf0e7335e, "sas_port_add_phy" },
	{ 0xec93fd86, "blk_mq_tagset_busy_iter" },
	{ 0x54b5acd4, "scsi_done" },
	{ 0xd5ccc957, "scsi_unblock_requests" },
	{ 0x10c1396d, "sas_phy_add" },
	{ 0xdcbeba1d, "sg_copy_from_buffer" },
	{ 0xa35c3c27, "sas_port_free" },
	{ 0x29977925, "kmalloc_trace" },
	{ 0x1e52d640, "scsi_block_requests" },
	{ 0xae054c65, "blk_abort_request" },
	{ 0xb5b54b34, "_raw_spin_unlock" },
	{ 0x16f123e, "sg_copy_to_buffer" },
	{ 0x58a2eaea, "sas_remove_children" },
	{ 0xce695e0b, "scsi_change_queue_depth" },
	{ 0x4b536e8a, "__pm_runtime_idle" },
	{ 0xeb233a45, "__kmalloc" },
	{ 0xe61a6d75, "kmalloc_caches" },
	{ 0x63d67aeb, "kmem_cache_destroy" },
	{ 0x17608925, "module_layout" },
};

MODULE_INFO(depends, "scsi_transport_sas");

